package com.ejie.ab79.dao.preguntasRespuestas;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;
import javax.sql.DataSource;

import org.springframework.dao.support.DataAccessUtils;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab79.model.REST.servicioWeb.Opcion;
import com.ejie.ab79.model.preguntasRespuestas.OpcionesPreExp;
import com.ejie.ab79.model.preguntasRespuestas.PreguntasExpediente;
import com.ejie.x38.dao.RowNumResultSetExtractor;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableManager;
import com.ejie.x38.dto.TableManagerJerarquia;
import com.ejie.x38.dto.TableRequestDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * OpcionesPreExpDaoImpl  
 * 
 *  
 */

@Repository
@Transactional
public class OpcionesPreExpDaoImpl implements OpcionesPreExpDao {

	public static final String[] ORDER_BY_WHITE_LIST = new String[] { "IDOPCIONPREEXP", "IDPREGUNTAEXPEDIENTE",
			"DESCRIPCIONCASTELLANO", "DESCRIPCIONEUSKERA", "FECHAREGISTRO", "USUARIOREGISTRO" };

	private JdbcTemplate jdbcTemplate;

	/*
	 * ROW_MAPPERS
	 */
	private RowMapper<OpcionesPreExp> rwMap = new RowMapper<OpcionesPreExp>() {
		public OpcionesPreExp mapRow(ResultSet resultSet, int rowNum) throws SQLException {
			return new OpcionesPreExp(resultSet.getInt("IDOPCIONPREEXP"), resultSet.getInt("IDPREGUNTAEXPEDIENTE"),
					resultSet.getString("DESCRIPCIONCASTELLANO"), resultSet.getString("DESCRIPCIONEUSKERA"),
					resultSet.getString("USUARIOREGISTRO"));
		}
	};

	private RowMapper<OpcionesPreExp> rwMapPK = new RowMapper<OpcionesPreExp>() {
		public OpcionesPreExp mapRow(ResultSet resultSet, int rowNum) throws SQLException {
			return new OpcionesPreExp(resultSet.getInt("IDOPCIONPREEXP"));
		}
	};

	/**
	 * Rowmapper para Jerarquía
	 *
	 * @param dataSource
	 *            DataSource
	 * @return
	 */
	private RowMapper<JerarquiaDto<OpcionesPreExp>> rwMapJerarquia = new RowMapper<JerarquiaDto<OpcionesPreExp>>() {
		public JerarquiaDto<OpcionesPreExp> mapRow(ResultSet resultSet, int rowNum) throws SQLException {

			OpcionesPreExp opcionespreexp = new OpcionesPreExp(resultSet.getInt("IDOPCIONPREEXP"),
					resultSet.getInt("IDPREGUNTAEXPEDIENTE"), resultSet.getString("DESCRIPCIONCASTELLANO"),
					resultSet.getString("DESCRIPCIONEUSKERA"), resultSet.getString("USUARIOREGISTRO"));

			JerarquiaDto<OpcionesPreExp> jerarquia = new JerarquiaDto<OpcionesPreExp>();
			jerarquia.setModel(opcionespreexp);
			jerarquia.setLevel(resultSet.getBigDecimal("LEVEL").intValue());
			jerarquia.setParentNodes(resultSet.getString("PARENTNODES"));
			jerarquia.setIsLeaf(Boolean.parseBoolean(resultSet.getString("ISLEAF")));
			jerarquia.setFilter(Boolean.parseBoolean(resultSet.getString("FILTER")));
			return jerarquia;
		}
	};

	private RowMapper<Opcion> rwMapOpcionesREST = new RowMapper<Opcion>() {
		public Opcion mapRow(ResultSet resultSet, int rowNum) throws SQLException {

			Opcion opcion = new Opcion();
			opcion.setIdentificadorOpcion(resultSet.getInt("identificadoropcion"));
			opcion.setDescripcionCastellano(resultSet.getString("descripcioncastellano"));
			opcion.setDescripcionEuskera(resultSet.getString("descripcioneuskera"));

			return opcion;
		}
	};

	/**
	 * Method use to set the datasource.
	 *
	 * @param dataSource
	 *            DataSource
	 * @return
	 */
	@Resource
	public void setDataSource(DataSource dataSource) {
		this.jdbcTemplate = new JdbcTemplate(dataSource);
	}

	/*
	 * OPERACIONES CRUD
	 */

	/**
	 * Inserts a single row in the OpcionesPreExp table.
	 *
	 * @param opcionespreexp
	 *            OpcionesPreExp
	 * @return OpcionesPreExp
	 */
	public OpcionesPreExp add(OpcionesPreExp opcionespreexp) {
		String query = "INSERT INTO OPCIONES_PRE_EXP (ID_OPCION_PRE_EXP, ID_PREGUNTA_EXPEDIENTE, DESCRIPCION_CASTELLANO, DESCRIPCION_EUSKERA, FECHA_REGISTRO, USUARIO_REGISTRO, ID_OPCION_MOVIL) VALUES (S_AB7921T00.NEXTVAL,?,?,?,SYSDATE,?,?)";
		this.jdbcTemplate.update(query, opcionespreexp.getIdPreguntaExpediente(),
				opcionespreexp.getDescripcionCastellano(), opcionespreexp.getDescripcionEuskera(),
				opcionespreexp.getUsuarioRegistro(), opcionespreexp.getIdOpcionMovil());
		return opcionespreexp;
	}

	/**
	 * Updates a single row in the OpcionesPreExp table.
	 *
	 * @param opcionespreexp
	 *            OpcionesPreExp
	 * @return OpcionesPreExp
	 */
	public OpcionesPreExp update(OpcionesPreExp opcionespreexp) {
		String query = "UPDATE OPCIONES_PRE_EXP SET ID_PREGUNTA_EXPEDIENTE=?, DESCRIPCION_CASTELLANO=?, DESCRIPCION_EUSKERA=? WHERE ID_OPCION_PRE_EXP=?";
		this.jdbcTemplate.update(query, opcionespreexp.getIdPreguntaExpediente(),
				opcionespreexp.getDescripcionCastellano(), opcionespreexp.getDescripcionEuskera(),
				opcionespreexp.getIdOpcionPreExp());
		return opcionespreexp;
	}

	/**
	 * Finds a single row in the OpcionesPreExp table.
	 *
	 * @param opcionespreexp
	 *            OpcionesPreExp
	 * @return OpcionesPreExp
	 */
	@Transactional(readOnly = true)
	public OpcionesPreExp find(OpcionesPreExp opcionespreexp) {
		String query = "SELECT t1.ID_OPCION_PRE_EXP IDOPCIONPREEXP, t1.ID_PREGUNTA_EXPEDIENTE IDPREGUNTAEXPEDIENTE, t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO, t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA, t1.FECHA_REGISTRO FECHAREGISTRO, t1.USUARIO_REGISTRO USUARIOREGISTRO FROM OPCIONES_PRE_EXP t1  WHERE t1.ID_OPCION_PRE_EXP = ?  ";

		List<OpcionesPreExp> opcionespreexpList = this.jdbcTemplate.query(query, this.rwMap,
				opcionespreexp.getIdOpcionPreExp());
		return (OpcionesPreExp) DataAccessUtils.uniqueResult(opcionespreexpList);
	}

	@Override
	public OpcionesPreExp findByIdOpcionMovil(String idOpcionMovil, Integer idPreguntaExpediente) {
		String query = "SELECT t1.ID_OPCION_PRE_EXP IDOPCIONPREEXP, t1.ID_PREGUNTA_EXPEDIENTE IDPREGUNTAEXPEDIENTE, t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO, t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA, t1.FECHA_REGISTRO FECHAREGISTRO, t1.USUARIO_REGISTRO USUARIOREGISTRO FROM OPCIONES_PRE_EXP t1  WHERE t1.ID_OPCION_MOVIL = ? AND t1.ID_PREGUNTA_EXPEDIENTE = ? ";

		List<OpcionesPreExp> opcionespreexpList = this.jdbcTemplate.query(query, this.rwMap, idOpcionMovil,
				idPreguntaExpediente);
		return (OpcionesPreExp) DataAccessUtils.uniqueResult(opcionespreexpList);
	}

	/**
	 * Removes a single row in the OpcionesPreExp table.
	 *
	 * @param opcionespreexp
	 *            OpcionesPreExp
	 * @return
	 */
	public void remove(OpcionesPreExp opcionespreexp) {
		String query = "DELETE FROM OPCIONES_PRE_EXP WHERE ID_OPCION_PRE_EXP=?";
		this.jdbcTemplate.update(query, opcionespreexp.getIdOpcionPreExp());
	}

	@Override
	public void removeByIdPreguntaExpediente(PreguntasExpediente preguntaExpediente) {
		String query = "DELETE FROM OPCIONES_PRE_EXP WHERE ID_PREGUNTA_EXPEDIENTE = ?";
		this.jdbcTemplate.update(query, preguntaExpediente.getIdPreguntaExpediente());
	}

	/**
	 * Exporta Datos al clipBoard
	 *
	 */
	public List<OpcionesPreExp> getMultiple(OpcionesPreExp filterOpcionesPreExp, TableRequestDto tableRequestDto,
			Boolean startsWith) {

		// Where clause & Params
		Map<String, Object> mapaWhere = this.getWhereLikeMap(filterOpcionesPreExp, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));

		@SuppressWarnings("unchecked")
		List<Object> params = (List<Object>) mapaWhere.get("params");

		StringBuilder sbMultipleSQL = TableManager.getSelectMultipleQuery(tableRequestDto, OpcionesPreExp.class, params,
				"ID_OPCION_PRE_EXP");

		return this.jdbcTemplate.query(sbMultipleSQL.toString(), this.rwMap, params.toArray());
	}

	/**
	 * Finds a list of rows in the OpcionesPreExp table.
	 *
	 * @param opcionespreexp
	 *            OpcionesPreExp
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<OpcionesPreExp>
	 */
	@Transactional(readOnly = true)
	public List<OpcionesPreExp> findAll(OpcionesPreExp opcionespreexp, TableRequestDto tableRequestDto) {
		StringBuilder query = new StringBuilder(
				"SELECT  t1.ID_OPCION_PRE_EXP IDOPCIONPREEXP,t1.ID_PREGUNTA_EXPEDIENTE IDPREGUNTAEXPEDIENTE,t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO,t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO ");
		query.append("FROM OPCIONES_PRE_EXP t1 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(opcionespreexp);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		if (tableRequestDto != null) {
			query = TableManager.getPaginationQuery(tableRequestDto, query, OpcionesPreExpDaoImpl.ORDER_BY_WHITE_LIST);
		}

		return (List<OpcionesPreExp>) this.jdbcTemplate.query(query.toString(), this.rwMap, params.toArray());
	}

	/**
	 * Finds rows in the OpcionesPreExp table using like.
	 *
	 * @param opcionespreexp
	 *            OpcionesPreExp
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<OpcionesPreExp>
	 */
	@Transactional(readOnly = true)
	public List<OpcionesPreExp> findAllLike(OpcionesPreExp opcionespreexp, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		StringBuilder query = new StringBuilder(
				"SELECT  t1.ID_OPCION_PRE_EXP IDOPCIONPREEXP,t1.ID_PREGUNTA_EXPEDIENTE IDPREGUNTAEXPEDIENTE,t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO,t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO ");
		query.append("FROM OPCIONES_PRE_EXP t1 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(opcionespreexp, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		if (tableRequestDto != null) {
			query = TableManager.getPaginationQuery(tableRequestDto, query, OpcionesPreExpDaoImpl.ORDER_BY_WHITE_LIST);
		}

		return (List<OpcionesPreExp>) this.jdbcTemplate.query(query.toString(), this.rwMap, params.toArray());
	}

	@Override
	public List<Opcion> findOpcionesREST(Integer idPreguntaExpediente) {
		String query = "SELECT t1.id_opcion_pre_exp identificadoropcion, t1.descripcion_castellano descripcioncastellano, t1.descripcion_euskera descripcioneuskera FROM opciones_pre_exp t1 WHERE t1.id_pregunta_expediente = ?";

		return (List<Opcion>) this.jdbcTemplate.query(query, this.rwMapOpcionesREST, idPreguntaExpediente);
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Counts rows in the OpcionesPreExp table.
	 *
	 * @param opcionespreexp
	 *            OpcionesPreExp
	 * @return Long
	 */
	@Transactional(readOnly = true)
	public Long findAllCount(OpcionesPreExp opcionespreexp) {
		StringBuilder query = new StringBuilder("SELECT COUNT(1) FROM OPCIONES_PRE_EXP t1 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(opcionespreexp);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Counts rows in the OpcionesPreExp table using like.
	 *
	 * @param opcionespreexp
	 *            OpcionesPreExp
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	@Transactional(readOnly = true)
	public Long findAllLikeCount(OpcionesPreExp opcionespreexp, Boolean startsWith) {
		StringBuilder query = new StringBuilder("SELECT COUNT(1) FROM OPCIONES_PRE_EXP t1 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(opcionespreexp, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Reorder the data list of OpcionesPreExp selected for rup_table
	 *
	 * @param opcionespreexp
	 *            OpcionesPreExp
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<OpcionesPreExp>>
	 */
	@Override
	public List<TableRowDto<OpcionesPreExp>> reorderSelection(OpcionesPreExp opcionespreexp,
			TableRequestDto tableRequestDto, Boolean startsWith) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_OPCION_PRE_EXP IDOPCIONPREEXP,t1.ID_PREGUNTA_EXPEDIENTE IDPREGUNTAEXPEDIENTE,t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO,t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO ");
		// FROM
		query.append("FROM OPCIONES_PRE_EXP t1 ");
		// FILTRADO
		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(opcionespreexp, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		// Parámetros de filtrado
		@SuppressWarnings("unchecked")
		List<Object> filterParamList = (List<Object>) mapaWhere.get("params");

		// SQL para la reordenación
		StringBuilder sbReorderSelectionSQL = TableManager.getReorderQuery(query, tableRequestDto, OpcionesPreExp.class,
				filterParamList, "ID_OPCION_PRE_EXP");

		return this.jdbcTemplate.query(sbReorderSelectionSQL.toString(),
				new RowNumResultSetExtractor<OpcionesPreExp>(this.rwMapPK, tableRequestDto), filterParamList.toArray());
	}

	/**
	 * Search method for rup_table
	 *
	 * @param filterParams
	 *            OpcionesPreExp
	 * @param searchParams
	 *            OpcionesPreExp
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<OpcionesPreExp>>
	 */
	@Override
	public List<TableRowDto<OpcionesPreExp>> search(OpcionesPreExp filterParams, OpcionesPreExp searchParams,
			TableRequestDto tableRequestDto, Boolean startsWith) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_OPCION_PRE_EXP IDOPCIONPREEXP,t1.ID_PREGUNTA_EXPEDIENTE IDPREGUNTAEXPEDIENTE,t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO,t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO ");
		// FROM
		query.append("FROM OPCIONES_PRE_EXP t1 ");
		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// FILTRADO
		Map<String, ?> mapaWhereFilter = this.getWhereLikeMap(filterParams, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhereFilter.get("query"));
		query.append(where);
		// Filter params
		@SuppressWarnings("unchecked")
		List<Object> filterParamList = (List<Object>) mapaWhereFilter.get("params");

		// BUSQUEDA
		Map<String, Object> mapaWhereSearch = this.getWhereLikeMap(searchParams, startsWith);
		String searchSQL = ((StringBuilder) mapaWhereSearch.get("query")).toString();
		// Search params
		@SuppressWarnings("unchecked")
		List<Object> searchParamList = (List<Object>) mapaWhereSearch.get("params");

		// SQL
		StringBuilder sbReorderSelectionSQL = TableManager.getSearchQuery(query, tableRequestDto, OpcionesPreExp.class,
				filterParamList, searchSQL, searchParamList, from_alias, "ID_OPCION_PRE_EXP");

		return this.jdbcTemplate.query(sbReorderSelectionSQL.toString(),
				new RowNumResultSetExtractor<OpcionesPreExp>(this.rwMapPK, tableRequestDto), filterParamList.toArray());
	}

	/**
	 * Remove multiple method for rup_table
	 *
	 * @param filteropcionespreexp
	 *            OpcionesPreExp
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	@Override
	public void removeMultiple(OpcionesPreExp filteropcionespreexp, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		// SELECT
		/** TODO: select por clave */
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_OPCION_PRE_EXP IDOPCIONPREEXP,t1.ID_PREGUNTA_EXPEDIENTE IDPREGUNTAEXPEDIENTE,t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO,t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO ");
		// FROM
		query.append("FROM OPCIONES_PRE_EXP t1 ");

		// WHERE
		Map<String, Object> mapaWhere = this.getWhereLikeMap(filteropcionespreexp, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		@SuppressWarnings("unchecked")
		List<Object> params = (List<Object>) mapaWhere.get("params");

		StringBuilder sbRemoveMultipleSQL = TableManager.getRemoveMultipleQuery(tableRequestDto, OpcionesPreExp.class,
				query, params, "ID_OPCION_PRE_EXP");
		this.jdbcTemplate.update(sbRemoveMultipleSQL.toString(), params.toArray());
	}

	/**
	 * Filter in the hierarchical OpcionesPreExp table.
	 *
	 * @param filterOpcionesPreExp
	 *            OpcionesPreExp
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<JerarquiaDto<OpcionesPreExp>>
	 */
	@Override
	public List<JerarquiaDto<OpcionesPreExp>> findAllLikeJerarquia(OpcionesPreExp filterOpcionesPreExp,
			TableRequestDto tableRequestDto) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_OPCION_PRE_EXP IDOPCIONPREEXP,t1.ID_PREGUNTA_EXPEDIENTE IDPREGUNTAEXPEDIENTE,t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO,t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO ");
		// FROM
		// StringBuilder from = new StringBuilder("FROM OPCIONES_PRE_EXP t1 ");
		List<String> from = new ArrayList<String>();
		from.add("OPCIONES_PRE_EXP");
		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterOpcionesPreExp, false);

		// JERARQUIA
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		query = TableManagerJerarquia.getQuery(tableRequestDto, query, mapaWhere, "ID_OPCION_PRE_EXP", "ID_PADRE",
				"NOMBRE", from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// query = TableManagerJerarquia.getQuery(tableRequestDto, query,
		// mapaWhere, "ID", "ID_PADRE", "NOMBRE", from, from_alias, joins,
		// businessFilters, businessParams);

		// PAGINACION
		if (tableRequestDto != null) {
			query = TableManagerJerarquia.getPaginationQuery(tableRequestDto, query,
					OpcionesPreExpDaoImpl.ORDER_BY_WHITE_LIST);
		}

		List<?> params = (List<?>) mapaWhere.get("params");
		return this.jdbcTemplate.query(query.toString(), this.rwMapJerarquia, params.toArray());
	}

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterOpcionesPreExp
	 *            OpcionesPreExp
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return Long
	 */
	@Override
	public Long findAllLikeCountJerarquia(OpcionesPreExp filterOpcionesPreExp, TableRequestDto tableRequestDto) {
		// FROM
		// StringBuilder from = new StringBuilder("FROM OPCIONES_PRE_EXP t1 ");
		List<String> from = new ArrayList<String>();
		from.add("OPCIONES_PRE_EXP");

		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterOpcionesPreExp, false);

		// JERARQUIA
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		StringBuilder query = TableManagerJerarquia.getQueryCount(tableRequestDto, mapaWhere, "ID_OPCION_PRE_EXP",
				"ID_PADRE", from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// StringBuilder query =
		// TableManagerJerarquia.getQueryCount(tableRequestDto, mapaWhere, "ID",
		// "ID_PADRE", from, from_alias, joins, businessFilters,
		// businessParams);

		List<?> params = (List<?>) mapaWhere.get("params");
		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterOpcionesPreExp
	 *            OpcionesPreExp
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<TableRowDto<OpcionesPreExp>>
	 */
	@Override
	public List<TableRowDto<OpcionesPreExp>> findAllChild(OpcionesPreExp filterOpcionesPreExp,
			TableRequestDto tableRequestDto) {

		// FROM
		// StringBuilder from = new StringBuilder("FROM OPCIONES_PRE_EXP t1 ");
		List<String> from = new ArrayList<String>();
		from.add("OPCIONES_PRE_EXP");

		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterOpcionesPreExp, false);

		// MULTISELECCION
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		StringBuilder query = TableManagerJerarquia.getQueryChildren(tableRequestDto, mapaWhere, "ID_OPCION_PRE_EXP",
				"ID_PADRE", from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// StringBuilder query =
		// TableManagerJerarquia.getQueryChildren(tableRequestDto, mapaWhere,
		// "ID", "ID_PADRE", from, from_alias, joins, businessFilters,
		// businessParams);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.query(query.toString(),
				new RowNumResultSetExtractor<OpcionesPreExp>(this.rwMapPK, "ID_OPCION_PRE_EXP"), params.toArray());
	}

	/*
	 * MÉTODOS PRIVADOS
	 */

	/**
	 * Returns a map with the needed value to create the conditions to filter by
	 * the OpcionesPreExp entity
	 *
	 * @param opcionespreexp
	 *            OpcionesPreExp Bean with the criteria values to filter by.
	 * @return Map created with two keys key query stores the sql query syntax
	 *         key params stores the parameter values to be used in the
	 *         condition sentence.
	 */
	// CHECKSTYLE:OFF CyclomaticComplexity - Generación de código de UDA
	private Map<String, ?> getWhereMap(OpcionesPreExp opcionespreexp) {

		StringBuilder where = new StringBuilder(OpcionesPreExpDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (opcionespreexp != null && opcionespreexp.getIdOpcionPreExp() != null) {
			where.append(" AND t1.ID_OPCION_PRE_EXP = ?");
			params.add(opcionespreexp.getIdOpcionPreExp());
		}
		if (opcionespreexp != null && opcionespreexp.getIdPreguntaExpediente() != null) {
			where.append(" AND t1.ID_PREGUNTA_EXPEDIENTE = ?");
			params.add(opcionespreexp.getIdPreguntaExpediente());
		}
		if (opcionespreexp != null && opcionespreexp.getDescripcionCastellano() != null) {
			where.append(" AND t1.DESCRIPCION_CASTELLANO = ?");
			params.add(opcionespreexp.getDescripcionCastellano());
		}
		if (opcionespreexp != null && opcionespreexp.getDescripcionEuskera() != null) {
			where.append(" AND t1.DESCRIPCION_EUSKERA = ?");
			params.add(opcionespreexp.getDescripcionEuskera());
		}
		if (opcionespreexp != null && opcionespreexp.getUsuarioRegistro() != null) {
			where.append(" AND t1.USUARIO_REGISTRO = ?");
			params.add(opcionespreexp.getUsuarioRegistro());
		}

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}
	// CHECKSTYLE:ON CyclomaticComplexity - Generación de código de UDA

	/**
	 * Returns a map with the needed value to create the conditions to filter by
	 * the OpcionesPreExp entity
	 *
	 * @param opcionespreexp
	 *            OpcionesPreExp Bean with the criteria values to filter by.
	 * @param startsWith
	 *            Boolean
	 * @return Map created with two keys key query stores the sql query syntax
	 *         key params stores the parameter values to be used in the
	 *         condition sentence.
	 */
	// CHECKSTYLE:OFF CyclomaticComplexity - Generación de código de UDA
	private Map<String, Object> getWhereLikeMap(OpcionesPreExp opcionespreexp, Boolean startsWith) {

		StringBuilder where = new StringBuilder(OpcionesPreExpDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (opcionespreexp != null && opcionespreexp.getIdOpcionPreExp() != null) {
			where.append(" AND t1.ID_OPCION_PRE_EXP = ?");
			params.add(opcionespreexp.getIdOpcionPreExp());
		}
		if (opcionespreexp != null && opcionespreexp.getIdPreguntaExpediente() != null) {
			where.append(" AND t1.ID_PREGUNTA_EXPEDIENTE = ?");
			params.add(opcionespreexp.getIdPreguntaExpediente());
		}
		if (opcionespreexp != null && opcionespreexp.getDescripcionCastellano() != null) {
			where.append(" AND UPPER(t1.DESCRIPCION_CASTELLANO) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(opcionespreexp.getDescripcionCastellano().toUpperCase() + "%");
			} else {
				params.add("%" + opcionespreexp.getDescripcionCastellano().toUpperCase() + "%");
			}
			where.append(" AND t1.DESCRIPCION_CASTELLANO IS NOT NULL");
		}
		if (opcionespreexp != null && opcionespreexp.getDescripcionEuskera() != null) {
			where.append(" AND UPPER(t1.DESCRIPCION_EUSKERA) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(opcionespreexp.getDescripcionEuskera().toUpperCase() + "%");
			} else {
				params.add("%" + opcionespreexp.getDescripcionEuskera().toUpperCase() + "%");
			}
			where.append(" AND t1.DESCRIPCION_EUSKERA IS NOT NULL");
		}
		if (opcionespreexp != null && opcionespreexp.getUsuarioRegistro() != null) {
			where.append(" AND UPPER(t1.USUARIO_REGISTRO) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(opcionespreexp.getUsuarioRegistro().toUpperCase() + "%");
			} else {
				params.add("%" + opcionespreexp.getUsuarioRegistro().toUpperCase() + "%");
			}
			where.append(" AND t1.USUARIO_REGISTRO IS NOT NULL");
		}

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}
	// CHECKSTYLE:ON CyclomaticComplexity - Generación de código de UDA

	/**
	 * StringBuilder initilization value
	 */
	public static final int STRING_BUILDER_INIT = 4096;

}
